/* A Bison parser, made by GNU Bison 2.0.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     SYMBOL = 258,
     CLASSES = 259,
     PERMISSIONS = 260,
     TYPES = 261,
     ROLES = 262,
     USERS = 263,
     NEXT = 264,
     LPAREN = 265,
     RPAREN = 266,
     LBRACK = 267,
     RBRACK = 268,
     LBRACE = 269,
     RBRACE = 270,
     PLUS = 271,
     COMMA = 272,
     SEMICOLON = 273,
     IMPLY = 274,
     IFF = 275,
     OR = 276,
     AND = 277,
     NOT = 278,
     IN = 279,
     NOTIN = 280,
     EQ = 281,
     NEQ = 282,
     TRUE = 283,
     FALSE = 284,
     STATE = 285,
     ACTION = 286,
     INIT = 287,
     TRANS = 288,
     SPEC = 289,
     UNUSED = 290
   };
#endif
#define SYMBOL 258
#define CLASSES 259
#define PERMISSIONS 260
#define TYPES 261
#define ROLES 262
#define USERS 263
#define NEXT 264
#define LPAREN 265
#define RPAREN 266
#define LBRACK 267
#define RBRACK 268
#define LBRACE 269
#define RBRACE 270
#define PLUS 271
#define COMMA 272
#define SEMICOLON 273
#define IMPLY 274
#define IFF 275
#define OR 276
#define AND 277
#define NOT 278
#define IN 279
#define NOTIN 280
#define EQ 281
#define NEQ 282
#define TRUE 283
#define FALSE 284
#define STATE 285
#define ACTION 286
#define INIT 287
#define TRANS 288
#define SPEC 289
#define UNUSED 290




/* Copy the first part of user declarations.  */
#line 1 "parser.y"


/*
  A grammar for the SLAT Labeled Transition System syntax.
  Copyright (C) 2005 The MITRE Corporation

  Author: John D. Ramsdell

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
*/

#include <stdlib.h>
#include <stdio.h>
#include <slat/symbol.h>
#include <slat/formula.h>
#include <slat/action.h>

extern int yylex(void);
extern int yyerror(const char *);

static symbol_list_t one(symbol_t item)
{
  return mk_symbol_list(item, 0);
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 31 "parser.y"
typedef union YYSTYPE {
  symbol_t symbol;
  symbol_list_t symbol_list;
  int boolean;
  arrow_t arrow;
  arrow_list_t arrow_list;
  diagram_t diagram;
  diagram_list_t diagram_list;
  tran_t tran;
  tran_list_t tran_list;
  lts_t lts;
} YYSTYPE;
/* Line 190 of yacc.c.  */
#line 189 "parser.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 213 of yacc.c.  */
#line 201 "parser.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  55
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   277

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  36
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  24
/* YYNRULES -- Number of rules. */
#define YYNRULES  120
/* YYNRULES -- Number of states. */
#define YYNSTATES  250

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   290

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    14,    18,    22,
      26,    31,    36,    41,    45,    49,    53,    57,    61,    66,
      71,    76,    80,    84,    88,    92,    96,   101,   106,   111,
     116,   121,   126,   131,   136,   141,   145,   149,   153,   157,
     161,   166,   171,   176,   181,   186,   191,   196,   201,   206,
     210,   214,   217,   221,   225,   229,   233,   237,   239,   241,
     245,   249,   253,   257,   261,   265,   269,   273,   277,   281,
     285,   289,   292,   296,   300,   304,   308,   312,   314,   316,
     320,   324,   328,   332,   336,   340,   344,   348,   351,   355,
     359,   363,   367,   371,   375,   376,   378,   380,   384,   386,
     390,   395,   405,   406,   409,   410,   412,   414,   418,   423,
     424,   426,   435,   440,   445,   450,   455,   460,   463,   466,
     467
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      37,     0,    -1,    38,    -1,    44,    47,    -1,    51,    -1,
      29,    -1,    28,    -1,     6,    24,    41,    -1,     7,    24,
      41,    -1,     8,    24,    41,    -1,     6,     9,    24,    41,
      -1,     7,     9,    24,    41,    -1,     8,     9,    24,    41,
      -1,     4,    24,    41,    -1,     5,    24,    41,    -1,     6,
      25,    41,    -1,     7,    25,    41,    -1,     8,    25,    41,
      -1,     6,     9,    25,    41,    -1,     7,     9,    25,    41,
      -1,     8,     9,    25,    41,    -1,     4,    25,    41,    -1,
       5,    25,    41,    -1,     6,    26,     3,    -1,     7,    26,
       3,    -1,     8,    26,     3,    -1,     6,     9,    26,     3,
      -1,     7,     9,    26,     3,    -1,     8,     9,    26,     3,
      -1,     6,     9,    26,     6,    -1,     6,    26,     6,     9,
      -1,     7,     9,    26,     7,    -1,     7,    26,     7,     9,
      -1,     8,     9,    26,     8,    -1,     8,    26,     8,     9,
      -1,     4,    26,     3,    -1,     5,    26,     3,    -1,     6,
      27,     3,    -1,     7,    27,     3,    -1,     8,    27,     3,
      -1,     6,     9,    27,     3,    -1,     7,     9,    27,     3,
      -1,     8,     9,    27,     3,    -1,     6,     9,    27,     6,
      -1,     6,    27,     6,     9,    -1,     7,     9,    27,     7,
      -1,     7,    27,     7,     9,    -1,     8,     9,    27,     8,
      -1,     8,    27,     8,     9,    -1,     4,    27,     3,    -1,
       5,    27,     3,    -1,    23,    38,    -1,    38,    22,    38,
      -1,    38,    21,    38,    -1,    38,    20,    38,    -1,    38,
      19,    38,    -1,    10,    38,    11,    -1,    29,    -1,    28,
      -1,     6,    24,    41,    -1,     7,    24,    41,    -1,     8,
      24,    41,    -1,     6,    25,    41,    -1,     7,    25,    41,
      -1,     8,    25,    41,    -1,     6,    26,     3,    -1,     7,
      26,     3,    -1,     8,    26,     3,    -1,     6,    27,     3,
      -1,     7,    27,     3,    -1,     8,    27,     3,    -1,    23,
      39,    -1,    39,    22,    39,    -1,    39,    21,    39,    -1,
      39,    20,    39,    -1,    39,    19,    39,    -1,    10,    39,
      11,    -1,    29,    -1,    28,    -1,     4,    24,    41,    -1,
       5,    24,    41,    -1,     4,    25,    41,    -1,     5,    25,
      41,    -1,     4,    26,     3,    -1,     5,    26,     3,    -1,
       4,    27,     3,    -1,     5,    27,     3,    -1,    23,    40,
      -1,    40,    22,    40,    -1,    40,    21,    40,    -1,    40,
      20,    40,    -1,    40,    19,    40,    -1,    10,    40,    11,
      -1,    14,    42,    15,    -1,    -1,    43,    -1,     3,    -1,
      43,    17,     3,    -1,    45,    -1,    44,    18,    45,    -1,
      12,    46,    13,    39,    -1,    12,    46,    13,    39,    12,
      39,    18,    40,    13,    -1,    -1,    48,    47,    -1,    -1,
      18,    -1,    49,    -1,    48,    18,    49,    -1,    39,    17,
      40,    50,    -1,    -1,    16,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    -1,    30,     6,    24,    41,    -1,
      30,     7,    24,    41,    -1,    30,     8,    24,    41,    -1,
      31,     4,    24,    41,    -1,    31,     5,    24,    41,    -1,
      32,    39,    -1,    33,    38,    -1,    -1,    59,    34,    38,
      -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,    71,    71,    72,    73,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   176,   180,   181,   185,   186,   192,   193,
     197,   199,   204,   205,   208,   210,   214,   215,   219,   223,
     224,   230,   235,   239,   243,   247,   251,   255,   259,   263,
     264
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SYMBOL", "CLASSES", "PERMISSIONS",
  "TYPES", "ROLES", "USERS", "NEXT", "LPAREN", "RPAREN", "LBRACK",
  "RBRACK", "LBRACE", "RBRACE", "PLUS", "COMMA", "SEMICOLON", "IMPLY",
  "IFF", "OR", "AND", "NOT", "IN", "NOTIN", "EQ", "NEQ", "TRUE", "FALSE",
  "STATE", "ACTION", "INIT", "TRANS", "SPEC", "UNUSED", "$accept", "start",
  "transitions", "states", "actions", "set", "set_elems", "non_null_set",
  "diagrams", "diagram", "elems", "opt_semicolon", "non_null_elems",
  "arrow", "more", "lts", "type_def", "role_def", "user_def", "class_def",
  "permission_def", "init", "trans", "specs", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    36,    37,    37,    37,    38,    38,    38,    38,    38,
      38,    38,    38,    38,    38,    38,    38,    38,    38,    38,
      38,    38,    38,    38,    38,    38,    38,    38,    38,    38,
      38,    38,    38,    38,    38,    38,    38,    38,    38,    38,
      38,    38,    38,    38,    38,    38,    38,    38,    38,    38,
      38,    38,    38,    38,    38,    38,    38,    39,    39,    39,
      39,    39,    39,    39,    39,    39,    39,    39,    39,    39,
      39,    39,    39,    39,    39,    39,    39,    40,    40,    40,
      40,    40,    40,    40,    40,    40,    40,    40,    40,    40,
      40,    40,    40,    41,    42,    42,    43,    43,    44,    44,
      45,    45,    46,    46,    47,    47,    48,    48,    49,    50,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      59
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     3,     3,     3,
       4,     4,     4,     3,     3,     3,     3,     3,     4,     4,
       4,     3,     3,     3,     3,     3,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     3,     3,     3,     3,     3,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     3,
       3,     2,     3,     3,     3,     3,     3,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     3,     3,     3,     3,     3,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     3,     3,
       3,     3,     3,     3,     0,     1,     1,     3,     1,     3,
       4,     9,     0,     2,     0,     1,     1,     3,     4,     0,
       1,     8,     4,     4,     4,     4,     4,     2,     2,     0,
       3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,   102,     0,     6,
       5,     0,     0,     2,   104,    98,     4,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    58,    57,     0,
       0,   104,   106,    51,     0,     1,     0,     0,     0,     0,
     105,     3,     0,     0,    94,    13,    21,    35,    49,    14,
      22,    36,    50,     0,     0,     0,     0,     7,    15,    23,
       0,    37,     0,     0,     0,     0,     0,     8,    16,    24,
       0,    38,     0,     0,     0,     0,     0,     9,    17,    25,
       0,    39,     0,    56,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    71,     0,     0,
       0,     0,     0,     0,   105,   103,     0,    55,    54,    53,
      52,    99,     0,     0,     0,    96,     0,    95,    10,    18,
      26,    29,    40,    43,    30,    44,    11,    19,    27,    31,
      41,    45,    32,    46,    12,    20,    28,    33,    42,    47,
      34,    48,    59,    62,    65,    68,    60,    63,    66,    69,
      61,    64,    67,    70,    76,     0,     0,     0,     0,    78,
      77,   109,    75,    74,    73,    72,   100,   107,   112,     0,
       0,     0,     0,    93,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    87,   110,     0,     0,     0,     0,
     108,     0,   113,     0,     0,     0,     0,    97,    79,    81,
      83,    85,    80,    82,    84,    86,    92,    91,    90,    89,
      88,     0,   114,     0,     0,     0,     0,     0,   115,     0,
     117,     0,   119,     0,   116,   118,   111,   101,     0,   120
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,    12,    13,    49,   181,    65,   136,   137,    14,    15,
      50,    61,    51,    52,   210,    16,    17,    63,   134,   192,
     216,   236,   242,   246
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -167
static const short int yypact[] =
{
      92,   112,   124,    -1,     4,     8,   106,   117,   106,  -167,
    -167,    -3,    18,   154,    61,  -167,  -167,     6,    59,    59,
      90,    98,    59,    59,   102,   104,   173,    59,    59,    55,
     100,   177,    59,    59,    57,    71,   181,    59,    59,    13,
      19,    26,   185,   192,   198,   117,   117,  -167,  -167,   166,
     113,    91,  -167,  -167,    95,  -167,   106,   106,   106,   106,
     118,  -167,   172,   123,   129,  -167,  -167,  -167,  -167,  -167,
    -167,  -167,  -167,    59,    59,   125,   244,  -167,  -167,  -167,
     175,  -167,   204,    59,    59,    82,    85,  -167,  -167,  -167,
     205,  -167,   211,    59,    59,    46,    69,  -167,  -167,  -167,
     225,  -167,   231,  -167,    59,    59,   191,   238,    59,    59,
     245,   246,    59,    59,   248,   249,    48,  -167,    34,   117,
     117,   117,   117,   117,   117,  -167,    59,   154,    96,   158,
    -167,  -167,   229,   247,   223,  -167,   241,   240,  -167,  -167,
    -167,  -167,  -167,  -167,  -167,  -167,  -167,  -167,  -167,  -167,
    -167,  -167,  -167,  -167,  -167,  -167,  -167,  -167,  -167,  -167,
    -167,  -167,  -167,  -167,  -167,  -167,  -167,  -167,  -167,  -167,
    -167,  -167,  -167,  -167,  -167,   202,   206,    34,    34,  -167,
    -167,   146,   217,   142,   236,  -167,   135,  -167,  -167,    59,
     235,   256,   230,  -167,   259,    59,    59,   260,   261,    59,
      59,   262,   263,   122,  -167,  -167,    34,    34,    34,    34,
    -167,   117,  -167,    59,   243,   264,   239,  -167,  -167,  -167,
    -167,  -167,  -167,  -167,  -167,  -167,  -167,   224,   148,   250,
    -167,   171,  -167,    59,   251,   117,   237,    34,  -167,    59,
     217,   106,  -167,   139,  -167,   154,   234,  -167,   106,   154
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -167,  -167,    -6,   -39,  -166,   -18,  -167,  -167,  -167,   213,
    -167,   226,  -167,   150,  -167,  -167,  -167,  -167,  -167,  -167,
    -167,  -167,  -167,  -167
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      41,    66,    53,    54,    69,    70,   116,   117,    26,    77,
      78,   203,   204,    31,    87,    88,    99,    36,    55,    97,
      98,   100,   101,    27,    28,    29,    30,   102,    32,    33,
      34,    35,    37,    38,    39,    40,    62,   103,   175,   176,
     227,   228,   229,   230,   177,    56,    57,    58,    59,   156,
     127,   128,   129,   130,   157,   138,   139,   178,    79,   174,
      89,    80,   179,   180,    90,   146,   147,   119,   120,   121,
     122,   243,   158,    64,    91,   154,   155,   159,    92,    60,
     182,   183,   184,   185,   186,   148,   162,   163,   150,   149,
     166,   167,   151,    67,   170,   171,     1,     2,     3,     4,
       5,    68,     6,    81,     7,    71,    82,    72,   188,   124,
       1,     2,     3,     4,     5,     8,     6,    58,    59,   126,
       9,    10,    11,    42,    43,    44,   123,    45,   140,     8,
       7,   141,   135,   226,     9,    10,    18,    19,    20,    21,
      46,   206,   207,   208,   209,    47,    48,   211,    22,    23,
      24,    25,   247,   133,   119,   120,   121,   122,   206,   207,
     208,   209,   205,   121,   122,   206,   207,   208,   209,   208,
     209,   212,   231,    56,    57,    58,    59,   218,   219,   132,
      59,   222,   223,   118,   144,   119,   120,   121,   122,   237,
     119,   120,   121,   122,   164,   232,   240,    73,    74,    75,
      76,    83,    84,    85,    86,    93,    94,    95,    96,   104,
     105,   106,   107,   145,   152,   238,   108,   109,   110,   111,
     153,   244,   112,   113,   114,   115,   195,   196,   197,   198,
     199,   200,   201,   202,   160,   245,   119,   120,   121,   122,
     161,   165,   249,   206,   207,   208,   209,   142,   168,   169,
     143,   172,   173,   189,   191,   190,   193,   194,   122,   213,
     214,   215,   217,   220,   221,   224,   225,   233,   248,   234,
     241,   235,   209,   131,   187,   239,     0,   125
};

static const short int yycheck[] =
{
       6,    19,     8,     6,    22,    23,    45,    46,     9,    27,
      28,   177,   178,     9,    32,    33,     3,     9,     0,    37,
      38,     8,     3,    24,    25,    26,    27,     8,    24,    25,
      26,    27,    24,    25,    26,    27,    30,    11,     4,     5,
     206,   207,   208,   209,    10,    19,    20,    21,    22,     3,
      56,    57,    58,    59,     8,    73,    74,    23,     3,    11,
       3,     6,    28,    29,     7,    83,    84,    19,    20,    21,
      22,   237,     3,    14,     3,    93,    94,     8,     7,    18,
     119,   120,   121,   122,   123,     3,   104,   105,     3,     7,
     108,   109,     7,     3,   112,   113,     4,     5,     6,     7,
       8,     3,    10,     3,    12,     3,     6,     3,   126,    18,
       4,     5,     6,     7,     8,    23,    10,    21,    22,    24,
      28,    29,    30,     6,     7,     8,    13,    10,     3,    23,
      12,     6,     3,    11,    28,    29,    24,    25,    26,    27,
      23,    19,    20,    21,    22,    28,    29,    12,    24,    25,
      26,    27,    13,    30,    19,    20,    21,    22,    19,    20,
      21,    22,    16,    21,    22,    19,    20,    21,    22,    21,
      22,   189,   211,    19,    20,    21,    22,   195,   196,     7,
      22,   199,   200,    17,     9,    19,    20,    21,    22,    18,
      19,    20,    21,    22,     3,   213,   235,    24,    25,    26,
      27,    24,    25,    26,    27,    24,    25,    26,    27,    24,
      25,    26,    27,     9,     9,   233,    24,    25,    26,    27,
       9,   239,    24,    25,    26,    27,    24,    25,    26,    27,
      24,    25,    26,    27,     9,   241,    19,    20,    21,    22,
       9,     3,   248,    19,    20,    21,    22,     3,     3,     3,
       6,     3,     3,    24,    31,     8,    15,    17,    22,    24,
       4,    31,     3,     3,     3,     3,     3,    24,    34,     5,
      33,    32,    22,    60,   124,    24,    -1,    51
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     4,     5,     6,     7,     8,    10,    12,    23,    28,
      29,    30,    37,    38,    44,    45,    51,    52,    24,    25,
      26,    27,    24,    25,    26,    27,     9,    24,    25,    26,
      27,     9,    24,    25,    26,    27,     9,    24,    25,    26,
      27,    38,     6,     7,     8,    10,    23,    28,    29,    39,
      46,    48,    49,    38,     6,     0,    19,    20,    21,    22,
      18,    47,    30,    53,    14,    41,    41,     3,     3,    41,
      41,     3,     3,    24,    25,    26,    27,    41,    41,     3,
       6,     3,     6,    24,    25,    26,    27,    41,    41,     3,
       7,     3,     7,    24,    25,    26,    27,    41,    41,     3,
       8,     3,     8,    11,    24,    25,    26,    27,    24,    25,
      26,    27,    24,    25,    26,    27,    39,    39,    17,    19,
      20,    21,    22,    13,    18,    47,    24,    38,    38,    38,
      38,    45,     7,    30,    54,     3,    42,    43,    41,    41,
       3,     6,     3,     6,     9,     9,    41,    41,     3,     7,
       3,     7,     9,     9,    41,    41,     3,     8,     3,     8,
       9,     9,    41,    41,     3,     3,    41,    41,     3,     3,
      41,    41,     3,     3,    11,     4,     5,    10,    23,    28,
      29,    40,    39,    39,    39,    39,    39,    49,    41,    24,
       8,    31,    55,    15,    17,    24,    25,    26,    27,    24,
      25,    26,    27,    40,    40,    16,    19,    20,    21,    22,
      50,    12,    41,    24,     4,    31,    56,     3,    41,    41,
       3,     3,    41,    41,     3,     3,    11,    40,    40,    40,
      40,    39,    41,    24,     5,    32,    57,    18,    41,    24,
      39,    33,    58,    40,    41,    38,    59,    13,    34,    38
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  yyvsp[0] = yylval;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 71 "parser.y"
    { parsed_transition((yyvsp[0].tran)); }
    break;

  case 3:
#line 72 "parser.y"
    { parsed_diagrams(diagram_list_reverse((yyvsp[-1].diagram_list))); }
    break;

  case 4:
#line 73 "parser.y"
    { parsed_lts((yyvsp[0].lts)); }
    break;

  case 5:
#line 77 "parser.y"
    { (yyval.tran) = mk_tran_false(); }
    break;

  case 6:
#line 78 "parser.y"
    { (yyval.tran) = mk_tran_true(); }
    break;

  case 7:
#line 79 "parser.y"
    { (yyval.tran) = mk_tran_types((yyvsp[0].symbol_list)); }
    break;

  case 8:
#line 80 "parser.y"
    { (yyval.tran) = mk_tran_roles((yyvsp[0].symbol_list)); }
    break;

  case 9:
#line 81 "parser.y"
    { (yyval.tran) = mk_tran_users((yyvsp[0].symbol_list)); }
    break;

  case 10:
#line 82 "parser.y"
    { (yyval.tran) = mk_next_types((yyvsp[0].symbol_list)); }
    break;

  case 11:
#line 83 "parser.y"
    { (yyval.tran) = mk_next_roles((yyvsp[0].symbol_list)); }
    break;

  case 12:
#line 84 "parser.y"
    { (yyval.tran) = mk_next_users((yyvsp[0].symbol_list)); }
    break;

  case 13:
#line 85 "parser.y"
    { (yyval.tran) = mk_tran_classes((yyvsp[0].symbol_list)); }
    break;

  case 14:
#line 86 "parser.y"
    { (yyval.tran) = mk_tran_permissions((yyvsp[0].symbol_list)); }
    break;

  case 15:
#line 87 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_types((yyvsp[0].symbol_list))); }
    break;

  case 16:
#line 88 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_roles((yyvsp[0].symbol_list))); }
    break;

  case 17:
#line 89 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_users((yyvsp[0].symbol_list))); }
    break;

  case 18:
#line 90 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_next_types((yyvsp[0].symbol_list))); }
    break;

  case 19:
#line 91 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_next_roles((yyvsp[0].symbol_list))); }
    break;

  case 20:
#line 92 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_next_users((yyvsp[0].symbol_list))); }
    break;

  case 21:
#line 93 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_classes((yyvsp[0].symbol_list))); }
    break;

  case 22:
#line 94 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_permissions((yyvsp[0].symbol_list))); }
    break;

  case 23:
#line 95 "parser.y"
    { (yyval.tran) = mk_tran_types(one((yyvsp[0].symbol))); }
    break;

  case 24:
#line 96 "parser.y"
    { (yyval.tran) = mk_tran_roles(one((yyvsp[0].symbol))); }
    break;

  case 25:
#line 97 "parser.y"
    { (yyval.tran) = mk_tran_users(one((yyvsp[0].symbol))); }
    break;

  case 26:
#line 98 "parser.y"
    { (yyval.tran) = mk_next_types(one((yyvsp[0].symbol))); }
    break;

  case 27:
#line 99 "parser.y"
    { (yyval.tran) = mk_next_roles(one((yyvsp[0].symbol))); }
    break;

  case 28:
#line 100 "parser.y"
    { (yyval.tran) = mk_next_users(one((yyvsp[0].symbol))); }
    break;

  case 29:
#line 101 "parser.y"
    { (yyval.tran) = mk_same_types(); }
    break;

  case 30:
#line 102 "parser.y"
    { (yyval.tran) = mk_same_types(); }
    break;

  case 31:
#line 103 "parser.y"
    { (yyval.tran) = mk_same_roles(); }
    break;

  case 32:
#line 104 "parser.y"
    { (yyval.tran) = mk_same_roles(); }
    break;

  case 33:
#line 105 "parser.y"
    { (yyval.tran) = mk_same_users(); }
    break;

  case 34:
#line 106 "parser.y"
    { (yyval.tran) = mk_same_users(); }
    break;

  case 35:
#line 107 "parser.y"
    { (yyval.tran) = mk_tran_classes(one((yyvsp[0].symbol))); }
    break;

  case 36:
#line 108 "parser.y"
    { (yyval.tran) = mk_tran_permissions(one((yyvsp[0].symbol))); }
    break;

  case 37:
#line 109 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_types(one((yyvsp[0].symbol)))); }
    break;

  case 38:
#line 110 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_roles(one((yyvsp[0].symbol)))); }
    break;

  case 39:
#line 111 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_users(one((yyvsp[0].symbol)))); }
    break;

  case 40:
#line 112 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_next_types(one((yyvsp[0].symbol)))); }
    break;

  case 41:
#line 113 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_next_roles(one((yyvsp[0].symbol)))); }
    break;

  case 42:
#line 114 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_next_users(one((yyvsp[0].symbol)))); }
    break;

  case 43:
#line 115 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_same_types()); }
    break;

  case 44:
#line 116 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_same_types()); }
    break;

  case 45:
#line 117 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_same_roles()); }
    break;

  case 46:
#line 118 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_same_roles()); }
    break;

  case 47:
#line 119 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_same_users()); }
    break;

  case 48:
#line 120 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_same_users()); }
    break;

  case 49:
#line 121 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_classes(one((yyvsp[0].symbol)))); }
    break;

  case 50:
#line 122 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_permissions(one((yyvsp[0].symbol)))); }
    break;

  case 51:
#line 123 "parser.y"
    { (yyval.tran) = mk_tran_not((yyvsp[0].tran)); }
    break;

  case 52:
#line 124 "parser.y"
    { (yyval.tran) = mk_tran_and((yyvsp[-2].tran), (yyvsp[0].tran)); }
    break;

  case 53:
#line 125 "parser.y"
    { (yyval.tran) = mk_tran_or((yyvsp[-2].tran), (yyvsp[0].tran)); }
    break;

  case 54:
#line 126 "parser.y"
    { (yyval.tran) = mk_tran_iff((yyvsp[-2].tran), (yyvsp[0].tran)); }
    break;

  case 55:
#line 127 "parser.y"
    { (yyval.tran) = mk_tran_imply((yyvsp[-2].tran), (yyvsp[0].tran)); }
    break;

  case 56:
#line 128 "parser.y"
    { (yyval.tran) = (yyvsp[-1].tran); }
    break;

  case 57:
#line 132 "parser.y"
    { (yyval.tran) = mk_tran_false(); }
    break;

  case 58:
#line 133 "parser.y"
    { (yyval.tran) = mk_tran_true(); }
    break;

  case 59:
#line 134 "parser.y"
    { (yyval.tran) = mk_tran_types((yyvsp[0].symbol_list)); }
    break;

  case 60:
#line 135 "parser.y"
    { (yyval.tran) = mk_tran_roles((yyvsp[0].symbol_list)); }
    break;

  case 61:
#line 136 "parser.y"
    { (yyval.tran) = mk_tran_users((yyvsp[0].symbol_list)); }
    break;

  case 62:
#line 137 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_types((yyvsp[0].symbol_list))); }
    break;

  case 63:
#line 138 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_roles((yyvsp[0].symbol_list))); }
    break;

  case 64:
#line 139 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_users((yyvsp[0].symbol_list))); }
    break;

  case 65:
#line 140 "parser.y"
    { (yyval.tran) = mk_tran_types(one((yyvsp[0].symbol))); }
    break;

  case 66:
#line 141 "parser.y"
    { (yyval.tran) = mk_tran_roles(one((yyvsp[0].symbol))); }
    break;

  case 67:
#line 142 "parser.y"
    { (yyval.tran) = mk_tran_users(one((yyvsp[0].symbol))); }
    break;

  case 68:
#line 143 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_types(one((yyvsp[0].symbol)))); }
    break;

  case 69:
#line 144 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_roles(one((yyvsp[0].symbol)))); }
    break;

  case 70:
#line 145 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_users(one((yyvsp[0].symbol)))); }
    break;

  case 71:
#line 146 "parser.y"
    { (yyval.tran) = mk_tran_not((yyvsp[0].tran)); }
    break;

  case 72:
#line 147 "parser.y"
    { (yyval.tran) = mk_tran_and((yyvsp[-2].tran), (yyvsp[0].tran)); }
    break;

  case 73:
#line 148 "parser.y"
    { (yyval.tran) = mk_tran_or((yyvsp[-2].tran), (yyvsp[0].tran)); }
    break;

  case 74:
#line 149 "parser.y"
    { (yyval.tran) = mk_tran_iff((yyvsp[-2].tran), (yyvsp[0].tran)); }
    break;

  case 75:
#line 150 "parser.y"
    { (yyval.tran) = mk_tran_imply((yyvsp[-2].tran), (yyvsp[0].tran)); }
    break;

  case 76:
#line 151 "parser.y"
    { (yyval.tran) = (yyvsp[-1].tran); }
    break;

  case 77:
#line 155 "parser.y"
    { (yyval.tran) = mk_tran_false(); }
    break;

  case 78:
#line 156 "parser.y"
    { (yyval.tran) = mk_tran_true(); }
    break;

  case 79:
#line 157 "parser.y"
    { (yyval.tran) = mk_tran_classes((yyvsp[0].symbol_list)); }
    break;

  case 80:
#line 158 "parser.y"
    { (yyval.tran) = mk_tran_permissions((yyvsp[0].symbol_list)); }
    break;

  case 81:
#line 159 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_classes((yyvsp[0].symbol_list))); }
    break;

  case 82:
#line 160 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_permissions((yyvsp[0].symbol_list))); }
    break;

  case 83:
#line 161 "parser.y"
    { (yyval.tran) = mk_tran_classes(one((yyvsp[0].symbol))); }
    break;

  case 84:
#line 162 "parser.y"
    { (yyval.tran) = mk_tran_permissions(one((yyvsp[0].symbol))); }
    break;

  case 85:
#line 163 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_classes(one((yyvsp[0].symbol)))); }
    break;

  case 86:
#line 164 "parser.y"
    { (yyval.tran) = mk_tran_not(mk_tran_permissions(one((yyvsp[0].symbol)))); }
    break;

  case 87:
#line 165 "parser.y"
    { (yyval.tran) = mk_tran_not((yyvsp[0].tran)); }
    break;

  case 88:
#line 166 "parser.y"
    { (yyval.tran) = mk_tran_and((yyvsp[-2].tran), (yyvsp[0].tran)); }
    break;

  case 89:
#line 167 "parser.y"
    { (yyval.tran) = mk_tran_or((yyvsp[-2].tran), (yyvsp[0].tran)); }
    break;

  case 90:
#line 168 "parser.y"
    { (yyval.tran) = mk_tran_iff((yyvsp[-2].tran), (yyvsp[0].tran)); }
    break;

  case 91:
#line 169 "parser.y"
    { (yyval.tran) = mk_tran_imply((yyvsp[-2].tran), (yyvsp[0].tran)); }
    break;

  case 92:
#line 170 "parser.y"
    { (yyval.tran) = (yyvsp[-1].tran); }
    break;

  case 93:
#line 176 "parser.y"
    { (yyval.symbol_list) = (yyvsp[-1].symbol_list); }
    break;

  case 94:
#line 180 "parser.y"
    { (yyval.symbol_list) = 0; }
    break;

  case 95:
#line 181 "parser.y"
    { (yyval.symbol_list) = symbol_list_reverse((yyvsp[0].symbol_list)); }
    break;

  case 96:
#line 185 "parser.y"
    { (yyval.symbol_list) = one((yyvsp[0].symbol)); }
    break;

  case 97:
#line 186 "parser.y"
    { (yyval.symbol_list) = mk_symbol_list((yyvsp[0].symbol), (yyvsp[-2].symbol_list)); }
    break;

  case 98:
#line 192 "parser.y"
    { (yyval.diagram_list) = mk_diagram_list((yyvsp[0].diagram), 0); }
    break;

  case 99:
#line 193 "parser.y"
    { (yyval.diagram_list) = mk_diagram_list((yyvsp[0].diagram), (yyvsp[-2].diagram_list)); }
    break;

  case 100:
#line 198 "parser.y"
    { (yyval.diagram) = mk_diagram((yyvsp[-2].arrow_list), (yyvsp[0].tran), 0, 0); }
    break;

  case 101:
#line 200 "parser.y"
    { (yyval.diagram) = mk_diagram((yyvsp[-7].arrow_list), (yyvsp[-5].tran), (yyvsp[-3].tran), (yyvsp[-1].tran)); }
    break;

  case 102:
#line 204 "parser.y"
    { (yyval.arrow_list) = 0; }
    break;

  case 103:
#line 205 "parser.y"
    { (yyval.arrow_list) = arrow_list_reverse((yyvsp[-1].arrow_list)); }
    break;

  case 106:
#line 214 "parser.y"
    { (yyval.arrow_list) = mk_arrow_list((yyvsp[0].arrow), 0); }
    break;

  case 107:
#line 215 "parser.y"
    { (yyval.arrow_list) = mk_arrow_list((yyvsp[0].arrow), (yyvsp[-2].arrow_list)); }
    break;

  case 108:
#line 219 "parser.y"
    { (yyval.arrow) = mk_arrow((yyvsp[-3].tran), (yyvsp[-1].tran), (yyvsp[0].boolean)); }
    break;

  case 109:
#line 223 "parser.y"
    { (yyval.boolean) = 0; }
    break;

  case 110:
#line 224 "parser.y"
    { (yyval.boolean) = 1; }
    break;

  case 111:
#line 231 "parser.y"
    { (yyval.lts) = mk_lts((yyvsp[-7].symbol_list), (yyvsp[-6].symbol_list), (yyvsp[-5].symbol_list), (yyvsp[-4].symbol_list), (yyvsp[-3].symbol_list), (yyvsp[-2].tran), (yyvsp[-1].tran), tran_list_reverse((yyvsp[0].tran_list))); }
    break;

  case 112:
#line 235 "parser.y"
    { (yyval.symbol_list) = (yyvsp[0].symbol_list); }
    break;

  case 113:
#line 239 "parser.y"
    { (yyval.symbol_list) = (yyvsp[0].symbol_list); }
    break;

  case 114:
#line 243 "parser.y"
    { (yyval.symbol_list) = (yyvsp[0].symbol_list); }
    break;

  case 115:
#line 247 "parser.y"
    { (yyval.symbol_list) = (yyvsp[0].symbol_list); }
    break;

  case 116:
#line 251 "parser.y"
    { (yyval.symbol_list) = (yyvsp[0].symbol_list); }
    break;

  case 117:
#line 255 "parser.y"
    { (yyval.tran) = (yyvsp[0].tran); }
    break;

  case 118:
#line 259 "parser.y"
    { (yyval.tran) = (yyvsp[0].tran); }
    break;

  case 119:
#line 263 "parser.y"
    { (yyval.tran_list) = 0; }
    break;

  case 120:
#line 264 "parser.y"
    { (yyval.tran_list) = mk_tran_list((yyvsp[0].tran), (yyvsp[-2].tran_list)); }
    break;


    }

/* Line 1037 of yacc.c.  */
#line 1919 "parser.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {

		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 yydestruct ("Error: popping",
                             yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yydestruct ("Error: discarding lookahead",
              yytoken, &yylval);
  yychar = YYEMPTY;
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 267 "parser.y"


